写点什么

Centos7 下 Nginx 编译安装与脚本安装的记录

作者:edd
  • 2022 年 1 月 27 日
  • 本文字数:3806 字

    阅读完需:约 12 分钟

一、安装工具及依赖


yum install -y wget make cmake gcc gcc-c++ \


yum install -y pcre pcre-devel lib zlib-devel openssl openssl-devel


二、下载及解压 nginx


wget http://nginx.org/download/nginx-1.12.2.tar.gz && \


tar -xzvf nginx-1.12.2.tar.gz && rm -f nginx-1.12.2.tar.gz && cd nginx-1.12.2[root@localhost nginx-1.12.2]# pwd/usr/local/nginx-1.12.2


三、编译安装,都在解压的文件中进行,即可,with 和 without 是添加和删除模块。


./configure --prefix=/usr/local/nginx --with-http_ssl_module --with-http_realip_module --http-client-body-temp-path=/usr/local/var/tmp/nginx/client


    --http-proxy-temp-path=/usr/local/var/tmp/nginx/proxy         --http-fastcgi-temp-path=/usr/local/var/tmp/nginx/fcgi         --http-scgi-temp-path=/usr/local/var/tmp/nginx/scgi         --http-uwsgi-temp-path=/usr/local/var/tmp/nginx/uwsgi         --with-http_geoip_module         --with-http_stub_status_module/usr/local/var/tmp/nginx/proxy     --http-fastcgi-temp-path=/usr/local/var/tmp/nginx/fcgi     --http-scgi-temp-path=/usr/local/var/tmp/nginx/scgi     --http-uwsgi-temp-path=/usr/local/var/tmp/nginx/uwsgi     --with-http_geoip_module     --with-http_stub_status_module
复制代码


make && make install


四.检查安装


启动 Nginx,启动完之后检查 nginx 是否已经正常启动

[root@localhost nginx-1.12.2]# /usr/local/nginx/sbin/nginx

[root@localhost nginx-1.12.2]# ps -ef |grep nginx

root 12563 1 0 14:44 ? 00:00:00

nginx: master process /usr/local/nginx/sbin/nginx

nobody 12564 12563 0 14:44 ? 00:00:00 nginx: worker process


root 12568 3627 0 14:45 pts/1 00:00:00 grep --color=auto nginx


五、nginx 常用命令


/usr/local/nginx/sbin/nginx -s start 启动

nginx/usr/local/nginx/sbin/nginx -s stop 关闭

nginx/usr/local/nginx/sbin/nginx -s reload 重启 nginx


六、配置防火墙


[root@localhost nginx-1.12.2]# firewall-cmd --zone=public --add-port=80/tcp --permanentsuccess[root@localhost nginx-1.12.2]# firewall-cmd --reloadsuccess


七、测试 nginx 访问


通过浏览器访问 nginx 欢迎页,在地址栏输入:http://192.1680.122,如下图所示。



八、配置 nginx


nginx 最重要的配置文件 nginx.conf


 #user  nobody;  #开启进程数 <=cpu数worker_processes  1;  #错误日志保存位置#error_log  logs/error.log;#error_log  logs/error.log  notice;#error_log  logs/error.log  info;  #进程号保存文件#pid        logs/nginx.pid;    #每个进程最大连接数(最大连接=连接数x进程数)每个worker允许同时产生多少个链接,默认1024events {    worker_connections  1024;}    http {    #文件扩展名与文件类型映射表    include       mime.types;     #默认文件类型    default_type  application/octet-stream;      #日志文件输出格式 这个位置相于全局设置    #log_format  main  '$remote_addr - $remote_user [$time_local] "$request" '    #                  '$status $body_bytes_sent "$http_referer" '    #                  '"$http_user_agent" "$http_x_forwarded_for"';      #请求日志保存位置    #access_log  logs/access.log  main;      #打开发送文件    sendfile        on;    #tcp_nopush     on;      #keepalive_timeout  0;    #连接超时时间    keepalive_timeout  65;      #打开gzip压缩    #gzip  on;      server {        #监听端口        listen       80;        #监听域名        server_name  localhost;          #charset koi8-r;          #nginx访问日志放在logs/host.access.log下,并且使用main格式(还可以自定义格式)        #access_log  logs/host.access.log  main;                 #如果没有location更明确的匹配访问路径的话,访问请求都会被该location处理        location / {            #root指定nginx的根目录为/usr/local/nginx/html            root   html;             #默认访问文件,欢迎页先去html目录下找index.html,如果找不到再去找index.htm            index  index.html index.htm;        }          #error_page  404              /404.html;          # redirect server error pages to the static page /50x.html        #        #错误页面及其返回地址,错误码为500、502、503、504都会返回50.html错误页面。        error_page   500 502 503 504  /50x.html;        location = /50x.html {            root   html;        }          # proxy the PHP scripts to Apache listening on 127.0.0.1:80        #        #location ~ \.php$ {        #    proxy_pass   http://127.0.0.1;        #}          # pass the PHP scripts to FastCGI server listening on 127.0.0.1:9000        #        #location ~ \.php$ {        #    root           html;        #    fastcgi_pass   127.0.0.1:9000;        #    fastcgi_index  index.php;        #    fastcgi_param  SCRIPT_FILENAME  /scripts$fastcgi_script_name;        #    include        fastcgi_params;        #}          # deny access to .htaccess files, if Apache's document root        # concurs with nginx's one        #        #location ~ /\.ht {        #    deny  all;        #}    }        # another virtual host using mix of IP-, name-, and port-based configuration    #    #server {    #    listen       8000;    #    listen       somename:8080;    #    server_name  somename  alias  another.alias;      #    location / {    #        root   html;    #        index  index.html index.htm;    #    }    #}        # HTTPS server    #    #server {    #    listen       443 ssl;    #    server_name  localhost;      #    ssl_certificate      cert.pem;    #    ssl_certificate_key  cert.key;      #    ssl_session_cache    shared:SSL:1m;    #    ssl_session_timeout  5m;      #    ssl_ciphers  HIGH:!aNULL:!MD5;    #    ssl_prefer_server_ciphers  on;      #    location / {    #        root   html;    #        index  index.html index.htm;    #    }    #}  }
复制代码


[root@localhost nginx-1.12.2]# vi /usr/local/nginx/conf/nginx.conf


配置文件里可以添加多个 server,server 监听的端口不同,可以根据需要让 nginx 代理多个端口,每个端口指定去做某些事情。


9、脚本安装 nginx


 #!/usr/bin/env bashecho -e '\e[31mInstallation tools and dependencies\e[0m'yum install -y wget make cmake gcc gcc-c++ yum install -y pcre-devel lib zlib-devel openssl openssl-develif [ $? -eq 0 ];then    echo -e '\e[32mSuccessful!\e[0m'else    echo -e '\e[31mFailed\e[0m'    exit 0fiecho -e '\e[31mInstallation nginx\e[0m'wget http://nginx.org/download/nginx-1.12.2.tar.gz  \tar -xzvf  nginx-1.12.2.tar.gz && rm -f nginx-1.12.2.tar.gz && cd nginx-1.12.2 \./configure --prefix=/usr/local/nginx \make && make installif [ $? -eq 0 ];then    echo -e '\e[32mSuccessful!\e[0m'else    echo -e '\e[31mFailed\e[0m'    exit 0fiecho -e '\e[31mStart nginx\e[0m'/usr/local/nginx/sbin/nginxecho -e '\e[32mSuccessful!\e[0m'
复制代码


亲测成功!主要防火墙开放 80 端口!


9、创建 nginx 启动命令脚本 vi /etc/init.d/nginx


 #! /bin/bash# chkconfig: - 85 15PATH=/usr/local/nginxDESC="nginx daemon"NAME=nginxDAEMON=$PATH/sbin/$NAMECONFIGFILE=$PATH/conf/$NAME.confPIDFILE=$PATH/logs/$NAME.pidSCRIPTNAME=/etc/init.d/$NAMEset -e[ -x "$DAEMON" ] || exit 0do_start() {$DAEMON -c $CONFIGFILE || echo -n "nginx already running"}do_stop() {$DAEMON -s stop || echo -n "nginx not running"}do_reload() {$DAEMON -s reload || echo -n "nginx can't reload"}case "$1" instart)echo -n "Starting $DESC: $NAME"do_startecho ".";;stop)echo -n "Stopping $DESC: $NAME"do_stopecho ".";;reload|graceful)echo -n "Reloading $DESC configuration..."do_reloadecho ".";;restart)echo -n "Restarting $DESC: $NAME"do_stopdo_startecho ".";;*)echo "Usage: $SCRIPTNAME {start|stop|reload|restart}" >&2exit 3;;esacexit 0
复制代码


chmod a+x /etc/init.d/nginx #设置执行权限

chkconfig --add nginx #注册成服务

chkconfig nginx on #设置开机启动

#启动 nginx 服务

service nginx start

#停止 nginx 服务

service nginx stop

#重启 nginx 服务

service nginx restart

#重新读取 nginx 配置(这个最常用, 不用停止 nginx 服务就能使修改的配置生效)

service nginx reload

发布于: 刚刚阅读数: 2
用户头像

edd

关注

还未添加个人签名 2018.01.18 加入

还未添加个人简介

评论

发布
暂无评论
Centos7下Nginx编译安装与脚本安装的记录